

#install.packages('survival')
#install.packages("survminer")

library(survival)
library(survminer)

setwd("C:\\Users\\Peijun\\Desktop\\Ъȱٰ\\coxģ͹\\07")                 #ùĿ¼
rt=read.table("lassoSigExp.txt",header=T,sep="\t",check.names=F,row.names=1)  #ȡtrainļ
rt[,"futime"]=rt[,"futime"]/365

#ʹtrain鹹COXģ
multiCox=coxph(Surv(futime, fustat) ~ ., data = rt)
multiCox=step(multiCox,direction = "both")
multiCoxSum=summary(multiCox)

#ģϢ
outTab=data.frame()
outTab=cbind(
             coef=multiCoxSum$coefficients[,"coef"],
             HR=multiCoxSum$conf.int[,"exp(coef)"],
             HR.95L=multiCoxSum$conf.int[,"lower .95"],
             HR.95H=multiCoxSum$conf.int[,"upper .95"],
             pvalue=multiCoxSum$coefficients[,"Pr(>|z|)"])
outTab=cbind(id=row.names(outTab),outTab)
write.table(outTab,file="multiCox.xls",sep="\t",row.names=F,quote=F)

#ɭͼ
pdf(file="forest.pdf",
       width = 8,             #ͼƬĿ
       height = 5,            #ͼƬĸ߶
       )
ggforest(multiCox,
         main = "Hazard ratio",
         cpositions = c(0.02,0.22, 0.4), 
         fontsize = 0.7, 
         refLabel = "reference", 
         noDigits = 2)
dev.off()

#trainļ
riskScore=predict(multiCox,type="risk",newdata=rt)           #trainõģԤtrainƷ
coxGene=rownames(multiCoxSum$coefficients)
coxGene=gsub("`","",coxGene)
outCol=c("futime","fustat",coxGene)
medianTrainRisk=median(riskScore)
risk=as.vector(ifelse(riskScore>medianTrainRisk,"high","low"))
write.table(cbind(id=rownames(cbind(rt[,outCol],riskScore,risk)),cbind(rt[,outCol],riskScore,risk)),
    file="riskTrain.txt",
    sep="\t",
    quote=F,
    row.names=F)

#testļ
rtTest=read.table("test.txt",header=T,sep="\t",check.names=F,row.names=1)          #ȡtestļ
rtTest[,"futime"]=rtTest[,"futime"]/365
riskScoreTest=predict(multiCox,type="risk",newdata=rtTest)      #trainõģԤtestƷ
riskTest=as.vector(ifelse(riskScoreTest>medianTrainRisk,"high","low"))
write.table(cbind(id=rownames(cbind(rtTest[,outCol],riskScoreTest,riskTest)),cbind(rtTest[,outCol],riskScore=riskScoreTest,risk=riskTest)),
    file="riskTest.txt",
    sep="\t",
    quote=F,
    row.names=F)


