#install.packages("ggplot2")
#install.packages("ggpubr")
#install.packages("ggExtra")

#ð
library(ggplot2)
library(ggpubr)
library(ggExtra)


corFilter=0                    #ϵ
pvalueFilter=0.001             #Լpֵ
geneRiskFile="geneRisk.txt"          #geneļ
immuneRiskFile="immuneRisk.txt"      #immuneļ
setwd("C:\\Users\\Peijun\\Desktop\\hsxjw\\\\32")     #ùĿ¼

#ȡgeneļ
geneRisk=read.table(geneRiskFile,header=T,sep="\t",check.names=F,row.names=1)
geneRisk=geneRisk[,3:(ncol(geneRisk)-2)]

#ȡimmuneļ
immuneRisk=read.table(immuneRiskFile,header=T,sep="\t",check.names=F,row.names=1)
immuneRisk=immuneRisk[,3:(ncol(immuneRisk)-2)]

#Ʒȡ
sameSample=intersect(row.names(geneRisk),row.names(immuneRisk))
geneRisk=geneRisk[sameSample,]
immuneRisk=immuneRisk[sameSample,]

#Իѭ
outTab=data.frame()
for(gene in colnames(geneRisk)){
    #ϸѭ
	for(immune in colnames(immuneRisk)){
		x=as.numeric(geneRisk[,gene])
		y=as.numeric(immuneRisk[,immune])
		corT=cor.test(x,y)
		cor=corT$estimate
		pvalue=corT$p.value
		outTab=rbind(outTab,cbind(gene,immune,cor=cor,corPval=pvalue))
		if((abs(cor)>corFilter) & (pvalue<pvalueFilter)){
			#
			df1=as.data.frame(cbind(x,y))
			p1=ggplot(df1, aes(x, y)) + 
					 xlab(gene)+ylab(immune)+
					 geom_point()+ 
					 geom_smooth(method="lm",formula=y~x) + 
					 theme_bw()+
					 stat_cor(aes(x =x, y =y))
			pdfFile=paste0(gene,"_",immune,".pdf")
			pdf(file=pdfFile,width=5,height=5)
			print(p1)
			dev.off()
		}
	}
}
#ͺԱļ
write.table(file="corResult.xls",outTab,sep="\t",quote=F,row.names=F)


######ѧ: https://www.biowolf.cn/
######γ1: https://shop119322454.taobao.com
######γ2: https://ke.biowolf.cn
######γ3: https://ke.biowolf.cn/mobile
######⿡ʦ䣺seqbio@foxmail.com
######⿡ʦ΢: seqBio
